﻿package  tv.snorkl.display.bitmap {
	
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.Sprite;
	import flash.display.DisplayObject;
	import flash.geom.Point;
	import flash.geom.Rectangle;
	import tv.snorkl.display.bitmap.BitmapTile;
	
	public class BitmapTileGrid extends Sprite{
		
		private var _rows:int;
		private var _cols:int;
		private var _tileWidth:int;
		private var _tileHeight:int;
		private var _bmdSource:BitmapData;
		private var _image:DisplayObject;
		private var _tilesArray2D:Array; // will eventually allow for easy access to each row of tiles and perhaps each column
		private var _tilesArray:Array; //an array of all the tiles. use public getter method below to access
		
		public function BitmapTileGrid(image:DisplayObject, cols:int, rows:int) {
			
			//note* add some stuff to validate params.
			
			_image = image;
			_rows = rows;
			_cols = cols;
			_tilesArray2D = [];
			_tilesArray = [];
			_bmdSource = new BitmapData(_image.width, image.height,true);
			_bmdSource.draw(_image);
			_tileWidth = _image.width / _cols;
			_tileHeight = _image.height / _rows;
			
			//construct the grid and also populate the _tilesArray2D and _tilesArray arrays. note _tilesArray2D still under construction.
			
			for (var r:Number=0; r<_rows; r++) {
				_tilesArray2D.push([]);
				for (var c:Number=0; c<_cols; c++) {
					var bmdCopy:BitmapData = new BitmapData(_tileWidth,_tileHeight, true);
					var left:Number = c * _tileWidth;
					var top:Number = r * _tileHeight;
					var right:Number = left + _tileWidth;
					var bottom:Number = top + _tileHeight;
					var rect:Rectangle = new Rectangle(left,top,right,bottom);
					var pt:Point = new Point(0,0);
					bmdCopy.copyPixels(_bmdSource, rect, pt);
					var bm:Bitmap = new Bitmap(bmdCopy);
					bm.smoothing = true;
					var bitmapTile:BitmapTile = new BitmapTile(bm, left, top);
					bitmapTile.x = bitmapTile.originX;
					bitmapTile.y = bitmapTile.originY;
					addChild(bitmapTile);
					_tilesArray2D[r][c] = bitmapTile;
					_tilesArray.push( bitmapTile);
					
				}
			}
			
		}
		
		// will return an array of all the tiles
		// makes it easy to loop through and target each tile in the grid
		// usage: var someArray:Array = myBitmapTileGrid.tilesArray;
		public function get tilesArray():Array{
			return _tilesArray;
			}
			
		public function get tileWidth():Number{
			return _tileWidth;
			}	
			
		public function get tileHeight():Number{
			return _tileHeight;
			}	

	}
	
}
